osgParticle::ModularEmitter Class Reference

`#include <ModularEmitter>`

Inheritance diagram for osgParticle::ModularEmitter:

## Public Member Functions

| ModularEmitter ()
| ModularEmitter (const ModularEmitter &copy, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Node (osgParticle, ModularEmitter)
Counter * | getCounter ()
| Get the counter object.
const Counter * | getCounter () const
| Get the const Counter object.
void | setCounter (Counter *c)
| Set the Counter object.
float | getNumParticlesToCreateMovementCompensationRatio () const
| Get the ratio between number of particle to create in compensation for movement of the emitter.
void | setNumParticlesToCreateMovementCompensationRatio (float r)
| Set the ratio between number of particle to create in compenstation for movement of the emitter.
Placer * | getPlacer ()
| Get the Placer object.
const Placer * | getPlacer () const
| Get the const Placer object.
void | setPlacer (Placer *p)
| Set the Placer object.
Shooter * | getShooter ()
| Get the Shooter object.
const Shooter * | getShooter () const
| Get the const Shooter object.
void | setShooter (Shooter *s)
| Set the Shooter object.
Public Member Functions inherited from osgParticle::Emitter
| Emitter ()
| Emitter (const Emitter &copy, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
virtual const char * | libraryName () const
virtual const char * | className () const
virtual bool | isSameKindAs (const osg::Object *obj) const
virtual void | accept (osg::NodeVisitor &nv)
void | setParticleSystem (ParticleSystem *ps)
| Set the destination particle system.
void | setEstimatedMaxNumOfParticles (int num)
int | getEstimatedMaxNumOfParticles () const
const Particle & | getParticleTemplate () const
| Get the particle template.
void | setParticleTemplate (const Particle &p)
| Set the particle template (particle is copied).
bool | getUseDefaultTemplate () const
| Return whether the particle system's default template should be used.
void | setUseDefaultTemplate (bool v)
Public Member Functions inherited from osgParticle::ParticleProcessor
| ParticleProcessor ()
| ParticleProcessor (const ParticleProcessor &copy, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
ReferenceFrame | getReferenceFrame () const
| Get the reference frame.
void | setReferenceFrame (ReferenceFrame rf)
| Set the reference frame.
bool | getEnabled () const
| Get whether this processor is enabled or not.
bool | isEnabled () const
void | setEnabled (bool v)
| Set whether this processor is enabled or not.
ParticleSystem * | getParticleSystem ()
| Get a pointer to the destination particle system.
const ParticleSystem * | getParticleSystem () const
| Get a const pointer to the destination particle system.
void | setEndless (bool type)
| Set the endless flag of this processor.
bool | getEndless () const
| Check whether this processor is endless.
bool | isEndless () const
void | setLifeTime (double t)
| Set the lifetime of this processor.
double | getLifeTime () const
| Get the lifetime of this processor.
void | setStartTime (double t)
| Set the start time of this processor.
double | getStartTime () const
| Get the start time of this processor.
void | setCurrentTime (double t)
| Set the current time of this processor.
double | getCurrentTime () const
| Get the current time of this processor.
void | setResetTime (double t)
| Set the reset time of this processor. A value of 0 disables reset.
double | getResetTime () const
| Get the reset time of this processor.
bool | isAlive () const
void | traverse (osg::NodeVisitor &nv)
const osg::Matrix & | getLocalToWorldMatrix ()
| Get the current local-to-world transformation matrix (valid only during cull traversal).
const osg::Matrix & | getWorldToLocalMatrix ()
| Get the current world-to-local transformation matrix (valid only during cull traversal).
const osg::Matrix & | getPreviousLocalToWorldMatrix ()
| Get the previous local-to-world transformation matrix (valid only during cull traversal).
const osg::Matrix & | getPreviousWorldToLocalMatrix ()
| Get the previous world-to-local transformation matrix (valid only during cull traversal).
osg::Vec3 | transformLocalToWorld (const osg::Vec3 &P)
| Transform a point from local to world coordinates (valid only during cull traversal).
osg::Vec3 | rotateLocalToWorld (const osg::Vec3 &P)
| Transform a vector from local to world coordinates, discarding translation (valid only during cull traversal).
osg::Vec3 | transformWorldToLocal (const osg::Vec3 &P)
| Transform a point from world to local coordinates (valid only during cull traversal).
osg::Vec3 | rotateWorldToLocal (const osg::Vec3 &P)
| Transform a vector from world to local coordinates, discarding translation (valid only during cull traversal).
virtual osg::BoundingSphere | computeBound () const
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | ascend (NodeVisitor &nv)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~ModularEmitter ()
ModularEmitter & | operator= (const ModularEmitter &)
virtual void | emitParticles (double dt)
Protected Member Functions inherited from osgParticle::Emitter
virtual | ~Emitter ()
Emitter & | operator= (const Emitter &)
void | process (double dt)
Protected Member Functions inherited from osgParticle::ParticleProcessor
virtual | ~ParticleProcessor ()
ParticleProcessor & | operator= (const ParticleProcessor &)
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Additional Inherited Members

Public Types inherited from osgParticle::ParticleProcessor
enum | ReferenceFrame { RELATIVE_RF , ABSOLUTE_RF }
Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Attributes inherited from osgParticle::Emitter
bool | _usedeftemp
Particle | _ptemp
int | _estimatedMaxNumOfParticles
Protected Attributes inherited from osgParticle::ParticleProcessor
ReferenceFrame | _rf
bool | _enabled
double | _t0
osg::ref_ptr< ParticleSystem > | _ps
bool | _first_ltw_compute
bool | _need_ltw_matrix
bool | _first_wtl_compute
bool | _need_wtl_matrix
osg::Matrix | _ltw_matrix
osg::Matrix | _wtl_matrix
osg::Matrix | _previous_ltw_matrix
osg::Matrix | _previous_wtl_matrix
osg::NodeVisitor * | _current_nodevisitor
bool | _endless
double | _lifeTime
double | _startTime
double | _currentTime
double | _resetTime
unsigned int | _frameNumber
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Detailed Description

An emitter class that holds three objects to control the creation of particles. These objects are a counter, a placer and a shooter. The counter controls the number of particles to be emitted at each frame; the placer must initialize the particle's position vector, while the shooter initializes its velocity vector. You can use the predefined counter/placer/shooter classes, or you can create your own.

## Constructor & Destructor Documentation

## ModularEmitter() [1/2]

osgParticle::ModularEmitter::ModularEmitter | ( |  | ) |

Referenced by META_Node(), ModularEmitter(), and operator=().

## ModularEmitter() [2/2]

osgParticle::ModularEmitter::ModularEmitter | ( | const ModularEmitter & | copy,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

References ModularEmitter(), and osg::CopyOp::SHALLOW_COPY.

## ~ModularEmitter()

virtual osgParticle::ModularEmitter::~ModularEmitter | ( |  | ) |

inline protected virtual

## Member Function Documentation

## emitParticles()

virtual void osgParticle::ModularEmitter::emitParticles | ( | double | dt | ) |

protected virtual

Implements osgParticle::Emitter.

## getCounter() [1/2]

Counter * osgParticle::ModularEmitter::getCounter | ( |  | ) |

inline

Get the counter object.

Referenced by META_Node().

## getCounter() [2/2]

const Counter * osgParticle::ModularEmitter::getCounter | ( |  | ) | const

inline

Get the const Counter object.

## getNumParticlesToCreateMovementCompensationRatio()

float osgParticle::ModularEmitter::getNumParticlesToCreateMovementCompensationRatio | ( |  | ) | const

inline

Get the ratio between number of particle to create in compensation for movement of the emitter.

Referenced by META_Node().

## getPlacer() [1/2]

Placer * osgParticle::ModularEmitter::getPlacer | ( |  | ) |

inline

Get the Placer object.

Referenced by META_Node().

## getPlacer() [2/2]

const Placer * osgParticle::ModularEmitter::getPlacer | ( |  | ) | const

inline

Get the const Placer object.

## getShooter() [1/2]

Shooter * osgParticle::ModularEmitter::getShooter | ( |  | ) |

inline

Get the Shooter object.

Referenced by META_Node().

## getShooter() [2/2]

const Shooter * osgParticle::ModularEmitter::getShooter | ( |  | ) | const

inline

Get the const Shooter object.

## META_Node()

osgParticle::ModularEmitter::META_Node | ( | osgParticle | ,
|  | ModularEmitter | )

References getCounter(), getNumParticlesToCreateMovementCompensationRatio(), getPlacer(), getShooter(), ModularEmitter(), setCounter(), setNumParticlesToCreateMovementCompensationRatio(), setPlacer(), and setShooter().

## operator=()

ModularEmitter & osgParticle::ModularEmitter::operator= | ( | const ModularEmitter & |  | ) |

inline protected

References ModularEmitter().

## setCounter()

void osgParticle::ModularEmitter::setCounter | ( | Counter * | c | ) |

inline

Set the Counter object.

Referenced by META_Node().

## setNumParticlesToCreateMovementCompensationRatio()

void osgParticle::ModularEmitter::setNumParticlesToCreateMovementCompensationRatio | ( | float | r | ) |

inline

Set the ratio between number of particle to create in compenstation for movement of the emitter.

Referenced by META_Node().

## setPlacer()

void osgParticle::ModularEmitter::setPlacer | ( | Placer * | p | ) |

inline

Set the Placer object.

Referenced by META_Node().

## setShooter()

void osgParticle::ModularEmitter::setShooter | ( | Shooter * | s | ) |

inline

Set the Shooter object.

Referenced by META_Node().

The documentation for this class was generated from the following file:

- ModularEmitter